Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  blcksock, synsock;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure Button4Click(Sender: TObject);
    Procedure Button5Click(Sender: TObject);
    Procedure Button6Click(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  End;

Var
  Form1: TForm1;
  Sock: TTCPBlockSocket = Nil;

Implementation

{$R *.lfm}

{ TForm1 }

Procedure TForm1.Button1Click(Sender: TObject);
Begin
  sock := TTCPBlockSocket.Create;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Begin
  sock.CreateSocket;
  sock.setLinger(true, 10000);
  sock.bind(Edit1.text, Edit2.text);
End;

Procedure TForm1.Button3Click(Sender: TObject);
Begin
  sock.CloseSocket;
End;

Procedure TForm1.Button4Click(Sender: TObject);
Begin
  sock.Free;
  sock := Nil;
End;

Procedure TForm1.Button5Click(Sender: TObject);
Var
  s: String;
Begin
  // Laut Manual mus immer ein \r\n stehen
  s := edit3.text + '\r\n';
  Showmessage('Send result :' + inttostr(sock.SendBuffer(pchar(s), length(s))));
  // Oder
//    sock.SendString(edit3.text + '\r\n');
End;

Procedure TForm1.Button6Click(Sender: TObject);
Var
  acc: TTCPBlockSocket;
  s: String;
Begin
  // Eine Sekunde Lang versuchen etwas zu lesen !!
  Sock.Listen;
  If Sock.CanRead(1000) Then Begin
    acc := TTCPBlockSocket.create;
    Try
      acc.Socket := sock.Accept;
      Acc.GetSins;
      s := acc.RecvPacket(60000);
      Showmessage(s);
    Finally
      acc.Free;
    End;
  End
  Else
    showmessage('Error nothing to read.');
End;

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  //  edit1.text := '192.168.0.90';
  edit1.text := '192.168.168.101';
  edit2.text := '50290';
  edit3.text := 'version';
End;

End.

